#include <bits/stdc++.h>
using namespace std;

bool is_weak_character(char c) {
    switch (c) {
        case '0': case '1': case '2': case '3': case '4':
        case '5': case '6': case '7': case '8': case '9':
        case '+': case '-': case '*': case '/': case '=':
            return true;
        default:
            return false;
    }
}

bool is_neutral_character(char c) {
    switch (c) {
        case ' ': case ',': case '.': case '(': case ')':
        case '[': case ']': case '{': case '}': case '<': case '>':
            return true;
        default:
            return false;
    }
}

char get_matching_character(char c) {
    switch (c) {
        case ')': return '('; break;
        case '(': return ')'; break;
        case '<': return '>'; break;
        case '>': return '<'; break;
        case '[': return ']'; break;
        case ']': return '['; break;
        case '{': return '}'; break;
        case '}': return '{'; break;
        default: return c;
    }
}

int main() {
    int n;
    cin >> n >> ws;

    string s;
    getline(cin, s);

    vector<int> direction (n+1, 0);

    for (int i = 0; i < n; i++) {
        if ('a' <= s[i] && s[i] <= 'z') {
            direction[i] = +1;
        } else if ('A' <= s[i] && s[i] <= 'Z') {
            direction[i] = -1;
        } else {
            direction[i] = direction[i-1];
        }
    }

    vector<int> reversed (n+1);
    {
        int l = 0;
        int nnr = 0;
        for (int r = 1; r < n+1; r++) {
            if (r == n) { direction[r] = -direction[l]; }
            if (!is_neutral_character(s[r-1])) { nnr = r; }
            if (direction[l] != direction[r]) {
                if (direction[l] == -1 && direction[r] == +1) {
                    reversed[l] = +1; reversed[nnr] = -1;
                    reverse(s.begin()+l, s.begin()+nnr);
                    for (int i = l; i < nnr; i++) {
                        s[i] = get_matching_character(s[i]);
                    }
                }
                l = r;
            }
        }
    }

    partial_sum(reversed.begin(), reversed.end(), reversed.begin());

    {
        int l = 0;
        while (l < n) {
            while (l < n && !(is_weak_character(s[l]) && reversed[l])) { l++; }
            int r = l+1;
            while (r < n && is_weak_character(s[r]) && direction[r] == direction[r+1]) { r++; }

            if (r <= n) {
                reverse(s.begin()+l, s.begin()+r);
            }

            l = r+1;
        }
    }

    cout << s << "\n";
}
